<!doctype html>
<html>

<head>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.3/Chart.bundle.js"></script>
</head>

<body>
  <div style="width:100%;">
    <canvas id="canvas"></canvas>
  </div>
  <br>
  <form>
  <input type="radio" id="reference" name="mode" value="reference" checked="checked">
  <label for="kernel">Compare kernel execution time (reference kernel)</label>
  <br>
  <input type="radio" id="custom" name="mode" value="custom">
  <label for="kernel">Compare kernel execution time (custom kernel)</label>
  <br>
  <input type="radio" id="sepTanMat" name="mode" value="sepTanMat">
  <label for="kernel">Compare kernel execution time (separat tangent matrix)</label>
  </form>
  <br>
  <input type="file" id="input" accept=".json" multiple/>
  <script>
    const ctx = document.getElementById('canvas').getContext('2d');
    const input = document.getElementById('input');
    var cfg;
    var metaData;
    
    window.onload = function(event) {
      cfg = {
        type: 'bar',
        data: {
          labels: [],
          datasets: [{
            data: []
          }]
        },
        options: {
          legend: {
            display: false
          }
        }
      };
      window.myLine = new Chart(ctx, cfg);
    }

    input.onchange = function(event) {
      if (event.target.files.length != 3) {
        console.log("Error not 3 input files selected");
        return;
      }
      var fnames = [];
      for (var i = 0; i < event.target.files.length; ++i) {
        fnames[i] = event.target.files[i].name;
      }
      getMetaDataFromFname(fnames);
      readFiles(event.target.files);
    }

    function readFiles(list){
      jsonData = [];
      var promises = [];
      for (var file of list) {
        var filePromise = new Promise(resolve => {
          var reader = new FileReader();
          reader.readAsText(file);
          reader.onload = () => resolve(reader.result);
        });
        promises.push(filePromise);
      }
      Promise.all(promises).then(fileContents => {
        var rawDataSets = [];
        for (var i = 0; i < fileContents.length; ++i) {
          rawDataSets[i] = JSON.parse(fileContents[i]);
        }
        generateChart(rawDataSets);
      });
    }

    function generateChart(rawDataSets) {
      var set0 = rawDataSets[0].benchmarks;
      var set1 = rawDataSets[1].benchmarks;
      var set2 = rawDataSets[2].benchmarks;

      cfg.data.labels = [];
      cfg.data.datasets = [];

      var disp0 = {};
      var disp1 = {};
      var disp2 = {};
      disp0.data = [];
      disp1.data = [];
      disp2.data = [];

      var label0 = metaData[0].unified?"unified":"not unified";
      label0 += " and ";
      label0 += metaData[0].transposed?"transposed":"not transposed";
      var label1 = metaData[1].unified?"unified":"not unified";
      label1 += " and ";
      label1 += metaData[1].transposed?"transposed":"not transposed";
      var label2 = metaData[2].unified?"unified":"not unified";
      label2 += " and ";
      label2 += metaData[2].transposed?"transposed":"not transposed";

      disp0.label = label0;
      disp1.label = label1;
      disp2.label = label2;

      if (metaData[0].unified && !metaData[0].transposed) {
        disp0.backgroundColor = "tomato";
      }
      else if (!metaData[0].unified && !metaData[0].transposed) {
        disp0.backgroundColor = "steelblue";
      }
      else {
        disp0.backgroundColor = "seagreen";
      }

      if (metaData[1].unified && !metaData[1].transposed) {
        disp1.backgroundColor = "tomato";
      }
      else if (!metaData[1].unified && !metaData[1].transposed) {
        disp1.backgroundColor = "steelblue";
      }
      else {
        disp1.backgroundColor = "seagreen";
      }

      if (metaData[2].unified && !metaData[2].transposed) {
        disp2.backgroundColor = "tomato";
      }
      else if (!metaData[2].unified && !metaData[2].transposed) {
        disp2.backgroundColor = "steelblue";
      }
      else {
        disp2.backgroundColor = "seagreen";
      }

      var _separate0 = [];
      var _separate1 = [];
      var _separate2 = [];
      var _reference0 = [];
      var _reference1 = [];
      var _reference2 = [];
      var _custom0 = [];
      var _custom1 = [];
      var _custom2 = [];

      var buildSet0 = [];
      var buildSet1 = [];
      var buildSet2 = [];

      for (var i = 0; i < set0.length; ++i) {
        var info = parseBenchmarkName(set0[i].name);
        if (info.name == "BM_MATMUL_SEPARATE") {
          _separate0.push([info,set0[i]]);
        }
        else if (info.kernel == "matmul_reference") {
          _reference0.push([info,set0[i]]);
        }
        else {
          _custom0.push([info,set0[i]]);
        }
      }
      for (var i = 0; i < set1.length; ++i) {
        var info = parseBenchmarkName(set1[i].name);
        if (info.name == "BM_MATMUL_SEPARATE") {
          _separate1.push([info,set1[i]]);
        }
        else if (info.kernel == "matmul_reference") {
          _reference1.push([info,set1[i]]);
        }
        else {
          _custom1.push([info,set1[i]]);
        }
      }
      for (var i = 0; i < set2.length; ++i) {
        var info = parseBenchmarkName(set2[i].name);
        if (info.name == "BM_MATMUL_SEPARATE") {
          _separate2.push([info,set2[i]]);
        }
        else if (info.kernel == "matmul_reference") {
          _reference2.push([info,set2[i]]);
        }
        else {
          _custom2.push([info,set2[i]]);
        }
      }

      if (document.getElementById("reference").checked) {
        buildSet0 = _reference0;
        buildSet1 = _reference1;
        buildSet2 = _reference2;
      }
      else if (document.getElementById("custom").checked) {
        buildSet0 = _custom0;
        buildSet1 = _custom1;
        buildSet2 = _custom2;
      }
      else if (document.getElementById("sepTanMat").checked) {
        buildSet0 = _separate0;
        buildSet1 = _separate1;
        buildSet2 = _separate2;
      }
      else {
        return;
      }

      if (buildSet0.length != buildSet1.length || buildSet1.length != buildSet2.length) {
        console.log("Error sets of different sizes used");
        return;
      }

      for (var i = 0; i < buildSet0.length; ++i) {
        cfg.data.labels[i] = buildSet0[i][0].typeA+", "+buildSet0[i][0].typeB;
        disp0.data[i] = buildSet0[i][1].kernel;
        disp1.data[i] = buildSet1[i][1].kernel;
        disp2.data[i] = buildSet2[i][1].kernel;
      }
      cfg.options.scales = {
        xAxes: [{
          ticks: {
            lineHeight: 1,
            fontSize: 12
          },
          scaleLabel: {
            display: true,
            labelString: "Datatypes as 'type of A, type of B'"
          }
        }],
        yAxes: [{
          type: 'logarithmic',
          scaleLabel: {
            display: true,
            labelString: 'avg runtime [ms]'
          },
          ticks: {
            //min: 0
          }
        }]
      }
      cfg.options.legend = {
        display: true
      }
      cfg.options.title = {
        display: true,
        text: "Comparison of runtimes with respect to unified memory and transposed access"
      }

      cfg.data.datasets[0] = disp0;
      cfg.data.datasets[1] = disp1;
      cfg.data.datasets[2] = disp2;

      document.getElementById("reference").disabled = true;
      document.getElementById("custom").disabled = true;
      document.getElementById("sepTanMat").disabled = true;
      window.myLine.update();
    }

    function parseBenchmarkName(name) {
      var _name = name.substr(0, name.indexOf('<'));
      var _param_string = name.substr(name.indexOf('<')+1, name.length);
      var _param_string = _param_string.substr(0, _param_string.indexOf('>/'));
      var _params = _param_string.split(', ');

      var ret;
      if (_name == "BM_MATMUL") {
        ret = {
          name:   _name,
          typeA:  _params[0],
          tvsA:   '0',
          typeB:  _params[1],
          tvsB:   '0',
          kernel: _params[2].substr(_params[2].indexOf('::')+2, _params[2].length),
          dim:    _params[3],
          block_size_x: _params[4],
          block_size_y: _params[5]
        }
      }
      else if (_name == "BM_MATMUL_SEPARATE") {
        ret = {
          name:   _name,
          typeA:  _params[0],
          tvsA:   _params[1],
          typeB:  _params[2],
          tvsB:   _params[3],
          kernel: _params[4].substr(_params[4].indexOf('::')+2, _params[4].length),
          dim: _params[5],
          block_size_x: _params[6],
          block_size_y: _params[7]
        }
      }
      else {
        return {};
      }
      ret.typeA = replaceType(ret.typeA);
      ret.typeB = replaceType(ret.typeB);
      return ret;
    }

    function getMetaDataFromFname(fnames) {
      metaData = [];
      for (var i = 0; i < fnames.length; ++i) {
        var fields = fnames[i].split('_');
        fields[3] = fields[3].substring(0,fields[3].indexOf(".json"));
        metaData[i] = {
          unified: (fields[2]=="unified")?true:false,
          transposed: (fields[3]=="transposed")?true:false
        }
      }
    }

    function replaceType(type) {
      switch (type) {
        case 'float': return 'f';
        case 'double': return 'd';
        case 'ml_cuda::interval_t<float>': return 'if';
        case 'ml_cuda::interval_t<double>': return 'id';
        case 'ml_cuda::tangent_t<float>': return 'tf';
        case 'ml_cuda::tangent_t<float,4>': return 'tf4';
        case 'ml_cuda::tangent_t<float,16>': return 'tf16';
        case 'ml_cuda::tangent_t<float,64>': return 'tf64';
        case 'ml_cuda::tangent_t<double>': return 'td';
        case 'ml_cuda::tangent_t<double,4>': return 'td4';
        case 'ml_cuda::tangent_t<double,16>': return 'td16';
        case 'ml_cuda::tangent_t<double,64>': return 'td64';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float>>': return 'itf';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,4>>': return 'itf4';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,16>>': return 'itf16';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,64>>': return 'itf64';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double>>': return 'itd';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,4>>': return 'itd4';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,16>>': return 'itd16';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,64>>': return 'itd64';
        default: break;
      }
      return 'no_type';
    }
  </script>
</body>

</html>
